#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "agenda.h"
#include "disco.h"

/* Abre arquivo */
FP abrir(char *arquivo, char *modo)
{
  int modoAtual;

  if (strpbrk (modo, "w"))
    modoAtual = GDBM_WRCREAT;
  else
    modoAtual = GDBM_READER;

  return (gdbm_open  (arquivo, 512, modoAtual, 0644, 0));
}

/* Fechar arquivo. Se aberto em modo escrita, faz flush. */
void fechar(FP fp)
{
  gdbm_close(fp);
}

/* Grava agenda em arquivo */
int gravaAgenda (ENDERECO *agenda, int nelem, FP dbf)
{
  int status = 0, i;
  datum key, content;

  for (i=0; i < nelem && !status; i++) {
    key.dptr = agenda[i].nome;
    key.dsize = strlen(agenda[i].nome);
    content.dptr = (char *) (agenda + i);
    content.dsize = sizeof(ENDERECO);
    status = gdbm_store (dbf, key, content, GDBM_REPLACE);
  }

  return !status;
}

/* Le itens da agenda de arquivo */
ENDERECO *leAgenda (int nelem, FP dbf)
{
  ENDERECO *agenda;
  datum key, content;
  int i;

  agenda = (ENDERECO *) calloc (nelem, sizeof(ENDERECO));

  if (agenda) {
    key = gdbm_firstkey (dbf);
    for (i = 0; key.dptr; i++, key = gdbm_nextkey (dbf, key)) {
      content = gdbm_fetch (dbf, key);
      memcpy (agenda + i, content.dptr, content.dsize);
    }
  }
  
  return agenda;
}


